package com.engine.kq.cmd.shiftschedule;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.engine.common.biz.AbstractCommonCommand;
import com.engine.common.biz.SimpleBizLogger;
import com.engine.common.entity.BizLogContext;
import com.engine.core.interceptor.CommandContext;
import com.engine.kq.bean.KqShiftscheduleOperateLog;
import com.engine.kq.biz.*;
import org.apache.commons.lang3.StringUtils;
import weaver.common.DateUtil;
import weaver.conn.BatchRecordSet;
import weaver.conn.DBUtil;
import weaver.conn.RecordSet;
import weaver.general.BaseBean;
import weaver.general.TimeUtil;
import weaver.general.Util;
import weaver.hrm.HrmUserVarify;
import weaver.hrm.Reminder.KQAutoCardTask;
import weaver.hrm.User;
import weaver.hrm.resource.ResourceComInfo;
import weaver.systeminfo.SystemEnv;

import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.*;

public class SaveShiftScheduleCmd extends AbstractCommonCommand<Map<String, Object>> {

  private SimpleBizLogger logger;

  // 添加日志功能
  private  List<List<Object>> operateLogParams = new ArrayList<>();
  // 操作类型  操作人  考勤组名称+id  被修改人  被修改班次日期  被修改班次+id  排班设置行id
  private List<Object> operateLogParam = null;

  public SaveShiftScheduleCmd(Map<String, Object> params, User user) {
    this.user = user;
    this.params = params;
    this.logger = new SimpleBizLogger();
  }

  @Override
  public Map<String, Object> execute(CommandContext commandContext) {
    Map<String, Object> retmap = new HashMap<String, Object>();
    RecordSet rs = new RecordSet();
    BatchRecordSet bRs = new BatchRecordSet();
    String today = DateUtil.getCurrentDate();
    String sql = "";
    try{
      //必要的权限判断
      if(!HrmUserVarify.checkUserRight("HrmKQGroup:Add",user)) {
        retmap.put("status", "-1");
        retmap.put("message", SystemEnv.getHtmlLabelName(2012, user.getLanguage()));
        return retmap;
      }
      String data = Util.null2String(params.get("data"));
      JSONObject jsonObj = JSON.parseObject(data);
      KQGroupComInfo kqGroupComInfo = new KQGroupComInfo();
      KQShiftManagementComInfo kqShiftScheduleComInfo = new KQShiftManagementComInfo();
      ResourceComInfo rci = new ResourceComInfo();
      String groupId = Util.null2String(jsonObj.get("groupId"));
      JSONArray datas = jsonObj.getJSONArray("datas");

      List<List<Object>> paramInsert = new ArrayList<List<Object>>();
      List<List<Object>> paramUpdate = new ArrayList<List<Object>>();
      List<Object> params = null;
      String delIds = "";
      List<List<Object>> lsFormatParams = new ArrayList<>();
      List<Object> formatParams = null;
      List<List<Object>> lsDeleteParams = new ArrayList<>();
      List<Object> deleteParams = null;
      List<List<Object>> lscheckSerialParams = new ArrayList<>();
      List<Object> checkSerialParams = null;

      JSONObject resourceDataObj = null;
      JSONArray arrKqDataObj = null;
      JSONObject kqDataObj = null;
      KqShiftscheduleOperateLog bean = null;
      //获取所属月份用日期
      String ssyfDate = "";
      List<String> lsGroupMembers = new ArrayList<>();
      Map<String,Object> mapShiftScheduleOri = new HashMap<>();
      for(int i=0;datas!=null&&i<datas.size();i++){
        resourceDataObj = (JSONObject)datas.get(i);
        String resourceid = Util.null2String(resourceDataObj.get("resourceid"));
        lsGroupMembers.add(resourceid);
        arrKqDataObj = resourceDataObj.getJSONArray("kqdata");
        for(int j=0;arrKqDataObj!=null&&j<arrKqDataObj.size();j++) {
          kqDataObj = (JSONObject) arrKqDataObj.get(j);
          // 如果id为空，则代表原先是空白单元格
          String id = Util.null2String(kqDataObj.get("id"));
          String date = Util.null2String(kqDataObj.get("date"));
          if(!SaveShiftScheduleCmd.isDate(date)) {
            continue;
          }
          // 原先排班的班次id
          String oldSerialid = Util.null2String(kqDataObj.get("oldValue"));
          // 新班次id    如果 serialid是-999， oldValue是班次id，那么就是原先是有班次的，后面把班次删除了
          String serialid = Util.null2String(kqDataObj.get("serialid"));
          if(serialid.equals("-999"))serialid="";
          boolean needChange = false;
          //if(weaver.common.DateUtil.timeInterval(date,today)>0)continue;//今天之前的无需处理
          if(id.length()>0){  // 更新
            ssyfDate = date;
            if(serialid.length()==0 && oldSerialid.length() > 0){  //删除
              if(delIds.length()>0) {
                delIds+=",";
              }
              delIds+=id;
              bean = new KqShiftscheduleOperateLog(2,user.getLastname(),kqGroupComInfo.getGroupname(groupId)+"(id:"+groupId+")",rci.getLastname(resourceid),
                      date, ("-1".equals(oldSerialid) ? SystemEnv.getHtmlLabelName(26593, user.getLanguage()) : kqShiftScheduleComInfo.getSerial(oldSerialid)+"(id:"+oldSerialid+")"), id, "", user.getLanguage());
              addLog(bean);
            }else {
              if(!oldSerialid.equals(serialid) && oldSerialid.length() > 0) {
                needChange = true;
                params = new ArrayList<Object>();
                params.add(serialid);
                params.add(id);
                params.add(resourceid);
                paramUpdate.add(params);
                bean = new KqShiftscheduleOperateLog(1,user.getLastname(),kqGroupComInfo.getGroupname(groupId)+"(id:"+groupId+")",rci.getLastname(resourceid),
                        date, ("-1".equals(oldSerialid) ? SystemEnv.getHtmlLabelName(26593, user.getLanguage()) : kqShiftScheduleComInfo.getSerial(oldSerialid)+"(id:"+oldSerialid+")"), id,  ("-1".equals(serialid) ? SystemEnv.getHtmlLabelName(26593, user.getLanguage()) : kqShiftScheduleComInfo.getSerial(serialid)+"(id:"+serialid+")"), user.getLanguage());
                addLog(bean);
              }
            }
            mapShiftScheduleOri.put(date+"|"+resourceid,serialid);
          }else{  //新建
            if(serialid.length()==0)continue;
            if(!oldSerialid.equals(serialid)) {
              ssyfDate = date;
              needChange = true;
              params = new ArrayList<Object>();
              params.add(date);
              params.add(serialid);
              params.add(resourceid);
              params.add(groupId);
              paramInsert.add(params);
              bean = new KqShiftscheduleOperateLog(0,user.getLastname(),kqGroupComInfo.getGroupname(groupId)+"(id:"+groupId+")",rci.getLastname(resourceid),
                      date, "", id, ("-1".equals(serialid) ? SystemEnv.getHtmlLabelName(26593, user.getLanguage()) : kqShiftScheduleComInfo.getSerial(serialid)+"(id:"+serialid+")"), user.getLanguage());
              addLog(bean);
              mapShiftScheduleOri.put(date+"|"+resourceid,serialid);
            }
          }
          if(needChange) {
            deleteParams = new ArrayList<>();
            deleteParams.add(resourceid);
            deleteParams.add(date);
            lsDeleteParams.add(deleteParams);

            checkSerialParams = new ArrayList<>();
            checkSerialParams.add(resourceid);
            checkSerialParams.add(date);
            checkSerialParams.add(serialid);
            lscheckSerialParams.add(checkSerialParams);

            if(DateUtil.timeInterval(date,today)>=0) {
              formatParams = new ArrayList<>();
              formatParams.add(resourceid);
              formatParams.add(date);
              lsFormatParams.add(formatParams);
            }
          }
        }
      }

      BaseBean bb = new BaseBean();
      String fromDate = TimeUtil.getMonthBeginDay(ssyfDate);
      String toDate = TimeUtil.getMonthEndDay(ssyfDate);
      List<String> lsDateNew = new ArrayList<>();
      Calendar calNew = DateUtil.getCalendar();
      boolean isEndNew = false;
      for(String date=fromDate; !isEndNew;) {
        if(date.equals(toDate)) isEndNew = true;
        lsDateNew.add(date);
        calNew.setTime(DateUtil.parseToDate(date));
        date = DateUtil.getDate(calNew.getTime(), 1);
      }
      Map<String,Object> mapShiftScheduleAll = new HashMap<>();
      Set<String> unSavePerson = new HashSet<>();
      //上四休二校验,生成预排班数据结构
      for(String resourceid:lsGroupMembers){
        Map<String,Object> mapShiftScheduleChild = new HashMap<>();
        String sqlChild = " select id, resourceid, kqdate,serialid from kq_shiftschedule where (isdelete is null or  isdelete <> '1') and groupid=? ";
        //有客户提下面的sql有性能问题，在表数据较多，并且该表数据改动较为频率不适合建索引，所以对mapShiftSchedule先缓存的数据范围过滤下，没必要全表缓存
        sqlChild += " and kqdate>='"+fromDate+"' and kqdate<='"+toDate+"' ";
        rs.executeQuery(sqlChild,groupId);
        while(rs.next()){
          mapShiftScheduleChild.put(rs.getString("kqdate")+"|"+rs.getString("resourceid"),rs.getString("serialid"));
        }
        //生成这个人员这个月的预生成排班
        for(int i=0;i<lsDateNew.size();i++) {
          String date = lsDateNew.get(i);
          String bcidNew = Util.null2String(mapShiftScheduleOri.get(date+"|"+resourceid));
          if(StringUtils.isNotBlank(bcidNew)){
            //本次排班预生成班次id
            mapShiftScheduleAll.put(date+"|"+resourceid,bcidNew);
          }else{
            //本次排班未预生成id，检查历史生成的班次id，若历史也没有生效班次，且当天不是节假日，则不让保存
            String bcidOld = Util.null2String(mapShiftScheduleChild.get(date+"|"+resourceid));
            if(StringUtils.isNotBlank(bcidOld)){
              mapShiftScheduleAll.put(date+"|"+resourceid,bcidOld);
            }else{
              int changeType = getChangeType(groupId, date);
              if(changeType != 1){
                //该人员不让保存
                unSavePerson.add(resourceid);
              }
            }
          }
        }
      }
      bb.writeLog("unSavePerson"+JSONObject.toJSONString(unSavePerson));
      bb.writeLog("mapShiftScheduleAll"+JSONObject.toJSONString(mapShiftScheduleAll));

      // 校验是否满足上四休二规则：从当月第一个连续两天的休息班作为锚点，判断此休息班前后排班是否满足固定4天工作+2天休息的模式，
      // 如果当月存在法定节假日则默认跳过后继续排班。例如：周三为节假日，且当周一为第一天工作日，那么当周的排班结果为：周一~周二：
      // 2天工作日、周三：跳过、周四~周五：2天工作日、周六周日：2天休息班
      for(String resourceid:lsGroupMembers){
        bb.writeLog("resourceid"+resourceid);
        //遍历这个人员这个月的预生成排班
        for(int i=0;i<lsDateNew.size();i++) {
          String date = lsDateNew.get(i);
          String bcid = Util.null2String(mapShiftScheduleAll.get(date+"|"+resourceid));
          bb.writeLog("date"+date+"bcid"+bcid);
          if(StringUtils.isNotBlank(bcid)){
            //班次是否是休息班，是的话往后判断是否是两个连续休息班
            boolean checkXxb = checkXxr(bcid);
            if(checkXxb){
              //是休息班,往后找
              bb.writeLog("是休息班,往后找");
              boolean findNextXxb = true;
              Integer day = 1;
              while (findNextXxb){
                calNew.setTime(DateUtil.parseToDate(date));
                String dateNext = DateUtil.getDate(calNew.getTime(), day);
                day++;
                String bcidNext = Util.null2String(mapShiftScheduleAll.get(dateNext+"|"+resourceid));
                bb.writeLog("dateNext"+dateNext+"day"+day+"bcidNext"+bcidNext);
                if(StringUtils.isNotBlank(bcidNext)){
                  //找到了第一个有班次的
                  bb.writeLog("找到了第一个有班次的");
                  findNextXxb = false;
                  boolean checkXxbNext = checkXxr(bcidNext);
                  if(checkXxbNext){
                    //再往后找一个班次，该班次需要为工作日
                    //是休息班,往后找
                    bb.writeLog("也是休息班,再往后找");
                    boolean findNextXxb1 = true;
                    Integer day1 = 1;
                    while (findNextXxb1){
                      calNew.setTime(DateUtil.parseToDate(dateNext));
                      String dateNext1 = DateUtil.getDate(calNew.getTime(), day1);
                      day1++;
                      String bcidNext1 = Util.null2String(mapShiftScheduleAll.get(dateNext1+"|"+resourceid));
                      bb.writeLog("bcidNext1"+bcidNext1+"dateNext1"+dateNext1+"day1"+day1);
                      if(StringUtils.isNotBlank(bcidNext1)){
                        //不往后找了
                        boolean checkXxbNext1 = checkXxr(bcidNext1);
                        findNextXxb1 = false;
                        bb.writeLog("checkXxbNext1"+checkXxbNext1);
                        if(checkXxbNext1){
                          //存在三个连续的休息班，不符合上四休二
                          bb.writeLog("存在三个连续的休息班，不符合上四休二");
                          unSavePerson.add(resourceid);
                        }else{
                          i++;
                        }
                      }else{
                        i++;
                      }
                      //到最后一天也没找到,暂不处理
                      if(DateUtil.timeInterval(toDate,dateNext1)>=0){
                        findNextXxb1 = false;
                      }
                    }
                    //将date作为一个锚点，往前找并判断是否满足上四休二
                    boolean findBefore = true;
                    Integer dayB = -1;
                    //工作班数量
                    Integer gzbnum = 0;
                    //判断前面是否还有休息班标识
                    Integer xxbNo = 0;
                    while (findBefore){
                      calNew.setTime(DateUtil.parseToDate(date));
                      String dateBefore = DateUtil.getDate(calNew.getTime(), dayB);
                      dayB--;
                      String bcidBefore = Util.null2String(mapShiftScheduleAll.get(dateBefore+"|"+resourceid));
                      bb.writeLog("bcidBefore"+bcidBefore+"dateBefore"+dateBefore+"dayB"+dayB);
                      if(StringUtils.isNotBlank(bcidBefore)){
                        boolean checkXxbBefore = checkXxr(bcidBefore);
                        if(checkXxbBefore){
                          //找到了第一个休息班，判断间隔了多少个非休息班,不再找了
                          bb.writeLog("找到了第一个休息班，判断间隔了多少个非休息班,不再找了");
                          findBefore = false;
                          xxbNo = 1;
                        }else{
                          gzbnum ++;
                        }
                      }
                      //找到月初一号了，不找了
                      if(DateUtil.timeInterval(dateBefore,fromDate)>=0){
                        findBefore = false;
                      }
                    }
                    bb.writeLog("gzbnum"+gzbnum);
                    if(xxbNo == 1){
                      //当前锚点前面有休息班，若间隔工作班数量不为4，则不符合
                      if(gzbnum != 4){
                        bb.writeLog("当前锚点前面有休息班，若间隔工作班数量不为4，则不符合");
                        unSavePerson.add(resourceid);
                      }
                    }else{
                      //当前锚点是第一个休息班
                      if(gzbnum>4){
                        //锚点往前有超过四个工作班,不符合
                        bb.writeLog("当前锚点是第一个休息班,锚点往前有超过四个工作班,不符合");
                        unSavePerson.add(resourceid);
                      }
                    }

                  }else{
                    //找到的不是休息班，也认为不符合上四休二
                    bb.writeLog("找到的不是休息班，也认为不符合上四休二");
                    unSavePerson.add(resourceid);
                  }
                }else{
                  i++;
                }

                //到最后一天也没找到,暂不处理
                if(DateUtil.timeInterval(toDate,dateNext)>=0){
                  findNextXxb = false;
                }
              }
            }
          }
        }
      }
      bb.writeLog("unSavePerson"+JSONObject.toJSONString(unSavePerson));



      sql = " update kq_shiftschedule set serialid=?,isDelete=0 where id = ? ";
      for (int i = 0; paramUpdate != null && i < paramUpdate.size(); i++) {
        List<Object> update_params = paramUpdate.get(i);
        String serialid = Util.null2String(update_params.get(0));
        String id = Util.null2String(update_params.get(1));
        String resourceid = Util.null2String(update_params.get(2));
        if(unSavePerson.contains(resourceid)){
          //该人员不符合规则，不生效
        }else{
          rs.executeUpdate(sql, serialid,id);
        }
      }

      sql = "insert into kq_shiftschedule (kqdate,serialid,resourceid,groupid,isDelete) values(?,?,?,?,0)";
      for (int i = 0; paramInsert != null && i < paramInsert.size(); i++) {
        List<Object> insert_params = paramInsert.get(i);
        String kqdate = Util.null2String(insert_params.get(0));
        String serialid = Util.null2String(insert_params.get(1));
        String resourceid = Util.null2String(insert_params.get(2));
        String groupid = Util.null2String(insert_params.get(3));
        if(unSavePerson.contains(resourceid)){
          //该人员不符合规则，不生效
        }else{
          rs.executeUpdate(sql, kqdate,serialid,resourceid,groupid);
        }
      }

      if(delIds.length()>0){
        List sqlParams = new ArrayList();
        Object[] objects= DBUtil.transListIn(delIds,sqlParams);
        sql = "update kq_shiftschedule set isdelete =1 where id in("+objects[0]+") ";
        rs.executeUpdate(sql, sqlParams);
      }

      //删除之前的排的班次，一天只能有一个班次
      sql = " update kq_shiftschedule set isdelete =1 where (isdelete is null or isdelete <> '1') and resourceid = ? and kqdate = ? and groupid != "+groupId;
      for (int i = 0; lsDeleteParams != null && i < lsDeleteParams.size(); i++) {
        List<Object> delete_params = lsDeleteParams.get(i);
        String resourceid = Util.null2String(delete_params.get(0));
        String kqdate = Util.null2String(delete_params.get(1));
        if(unSavePerson.contains(resourceid)){
          //该人员不符合规则，不生效
        }else{
          rs.executeUpdate(sql, resourceid,kqdate);
        }
      }

      sql = " update kq_shiftschedule set isdelete =1 where (isdelete is null or isdelete <> '1') and resourceid = ? and kqdate = ? and serialid != ? ";
      for (int i = 0; lscheckSerialParams != null && i < lscheckSerialParams.size(); i++) {
        List<Object> check_params = lscheckSerialParams.get(i);
        String resourceid = Util.null2String(check_params.get(0));
        String kqdate = Util.null2String(check_params.get(1));
        String serialid = Util.null2String(check_params.get(2));
        if(unSavePerson.contains(resourceid)){
          //该人员不符合规则，不生效
        }else{
          rs.executeUpdate(sql, resourceid,kqdate,serialid);
        }
      }

      sql = "insert into kq_shiftscheduleoperate_log(operatetype,operator,kqgroupname,changeduser,changedshiftdate,changedshiftname,kqshiftid) values(?,?,?,?,?,?,?)";
      bRs.executeBatchSqlNew(sql, operateLogParams);

      new KQShiftScheduleComInfo().removeCache();

      //刷新报表数据
      new KQFormatBiz().format(lsFormatParams,16);

      KQGroupComInfo kQGroupComInfo = new KQGroupComInfo();
      String auto_checkout = kQGroupComInfo.getAuto_checkout(groupId);
      String auto_checkin = kQGroupComInfo.getAuto_checkin(groupId);
      if("1".equalsIgnoreCase(auto_checkin) || "1".equalsIgnoreCase(auto_checkout)){
        //如果开启了自动打卡，保存考勤组成员之后需要格式化下缓存
        KQAutoCardTask kqAutoCardTask = new KQAutoCardTask();
        kqAutoCardTask.initAutoCardTask(groupId);
      }

      if(unSavePerson.size()>0){
        ResourceComInfo resourceComInfo = new ResourceComInfo();
        List<String> personNameList = new ArrayList<>();
        for(String personid:unSavePerson){
          personNameList.add(resourceComInfo.getLastname(personid));
        }
        retmap.put("status", "-1");
        retmap.put("message", "【"+StringUtils.join(personNameList,",")+"】上述员工当前月份排班不符合做四休二规则或存在班次为空的日期");
        return retmap;
      }

      retmap.put("status", "1");
      retmap.put("message", SystemEnv.getHtmlLabelName(18758, user.getLanguage()));
    }catch (Exception e) {
      retmap.put("status", "-1");
      retmap.put("message",  SystemEnv.getHtmlLabelName(382661,user.getLanguage()));
      writeLog(e);
    }
    return retmap;
  }

  private void addLog(KqShiftscheduleOperateLog bean) {
    operateLogParam = new ArrayList<>();
    operateLogParam.add(bean.getOperatetype());
    operateLogParam.add(bean.getOperator());
    operateLogParam.add(bean.getKqgroupname());
    operateLogParam.add(bean.getChangeduser());
    operateLogParam.add(bean.getChangedshiftdate());
    operateLogParam.add(bean.getChangedshiftname());
    operateLogParam.add(bean.getKqshiftid());
    operateLogParams.add(operateLogParam);
  }

  public static boolean isDate(String str) {
    SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
    sdf.setLenient(false);  // 严格匹配
    try {
      sdf.parse(str);
      return true;
    } catch (ParseException e) {
      return false;
    }
  }

  /**
   * 获取当前日期是何种类型(这里只考虑节假日设置)
   *
   * @param groupId 考勤组ID
   * @param date    指定日期
   * @return 1-节假日、2-工作日、3-休息日、-1-没有设置过数据
   */
  public static int getChangeType(String groupId, String date) {
    int changeType = -1;//默认没有设置过节假日(节假日设置的类型：1-公众假日、2-调配工作日、3-调配休息日)
    KQHolidaySetComInfo kqHolidaySetComInfo = new KQHolidaySetComInfo();
    String tmpChangetype = kqHolidaySetComInfo.getChangeType(groupId, date);
    if(null != tmpChangetype){
      changeType = Util.getIntValue(tmpChangetype, -1);
    }

    return changeType;
  }

  /**
   * 判断是否是休息班
   * @param serialid
   * @return
   */
  private static Boolean checkXxr(String serialid){
    RecordSet rs = new RecordSet();
    String sql = "select * from kq_ShiftManagement where id = "+serialid+" and is_rest = 1";
    rs.execute(sql);
    Boolean check = false;
    if (rs.getCounts()>0){
      check = true;
    }
    return check;
  }

  @Override
  public BizLogContext getLogContext() {
    return null;
  }

  @Override
  public List<BizLogContext> getLogContexts() {
    return logger.getBizLogContexts();
  }
}
